(ns com-jakewindle-git.scraper
  (:require [clj-http.client :as client]
            [hickory.core :as hick]
            [hickory.select :as s]))

;; Models
(def stat-urls ["https://www.espn.com/nfl/stats/team/_/season/2011/seasontype/2"])

(defn not-nil [v]
  (not (nil? v)))

(defn new-page [uri]
  (-> uri
      (client/get)
      :body
      hick/parse
      hick/as-hickory))

(defn get-links [parsed]
  (-> (s/select (s/child (s/tag "a"))
                parsed)))

(defn links-to-text [links]
  (filter not-nil (map #(-> % :attrs :href) links)))

(defn init-crawler []
  (map #(new-page %) stat-urls))

;; Entities
(defn greet
  "Callable entry point to the application."
  [data]
  (println (str "Hello, " (or (:name data) "World") "!")))

(defn -main
  "I don't do a whole lot ... yet."
  [& args]
  (greet {:name (first args)}))
